.386

.MODEL FLAT, STDCALL

OPTION CASEMAP:NONE

INCLUDE    \masm32\include\windows.inc
INCLUDE    \masm32\include\user32.inc
INCLUDE    \masm32\include\kernel32.inc
INCLUDELIB \masm32\lib\kernel32.lib
INCLUDELIB \masm32\lib\user32.lib

.DATA

LibName          DB "DLLSkeleton.dll", 0
FunctionName     DB "TestHello", 0
DllNotFound      DB "Nie mona zaadowa biblioteki DLL", 0
AppName          DB "adowanie biblioteki DLL", 0
FunctionNotFound DB "Funkcja TestHello nie odnaleziona", 0

.DATA?

hLib          DD ?
TestHelloAddr DD ?

.CODE

start:

    INVOKE LoadLibrary, ADDR LibName

; Wywoaj LoadLibrary z nazw danej biblioteki DLL.
; Jeli wywoanie to si powiedzie, to zwrci uchwyt
; do biblioteki DLL. Jeli nie, to zwrci NULL.
; Uchwyt biblioteki DLL moesz przekaza do GetProcAddress
; lub dowolnej innej funkcji, ktra wymaga jako parametr
; uchwytu do biblioteki DLL.

    .IF eax==NULL
        INVOKE MessageBox, NULL,\
                           ADDR DllNotFound,\
                           ADDR AppName, MB_OK
    .ELSE
        mov    hLib, eax
        INVOKE GetProcAddress, hLib, ADDR FunctionName

; Gdy otrzymasz uchwyt do biblioteki DLL, przekazujesz go
; do funkcji GetProcAddress z adresem nazwy funkcji w tej
; bibliotece, ktr chcesz wywoa. Jeli wywoanie si
; powiedzie to jako warto zwrotn otrzymasz adres funkcji.
; W przeciwnym razie otrzymasz warto NULL. Adres funkcji
; nie ulega zmianom, chyba e usuniesz i ponownie zaadujesz
; t bibliotek DLL. Zatem moesz zachowa go w zmiennej
; globalnej do pniejszego wykorzystania.

        .IF eax==NULL
            INVOKE MessageBox, NULL,\
                               ADDR FunctionNotFound,\
                               ADDR AppName, MB_OK
        .ELSE
            mov TestHelloAddr, eax

; Nastpnie moesz wywoa dan funkcj z biblioteki DLL za pomoc
; prostego wywoania z adresem zmiennej jako argument zawierajcej
; adres funkcji bibliotecznej

            call [TestHelloAddr]
        .ENDIF
        INVOKE FreeLibrary, hLib

; Gdy ju nie potrzebujesz danej biblioteki DLL, usu j
; za pomoc funkcji FreeLibrary. 

    .ENDIF
    INVOKE ExitProcess, NULL

END start
